from RPi import GPIO
import time

cursorB = True
display = True


class LCD:
    def __init__(self, par_E, par_RS, par_lijst_D):
        GPIO.setmode(GPIO.BCM)
        GPIO.setup(par_RS, GPIO.OUT)
        GPIO.setup(par_E, GPIO.OUT)
        GPIO.setwarnings(False)
        for D in par_lijst_D:
            GPIO.setup(D, GPIO.OUT)
        GPIO.output(par_E, GPIO.HIGH)
        self.E = par_E
        self.RS = par_RS
        self.lijst_D = par_lijst_D

    def set_data_bits(self, value):
        GPIO.output(self.E, GPIO.HIGH)
        mask = 1
        for i in range(0, 8):
            bit = value & mask
            bit >>= i
            if bit == 1:
                GPIO.output(self.lijst_D[i], GPIO.HIGH)
            elif bit == 0:
                GPIO.output(self.lijst_D[i], GPIO.LOW)
            mask <<= 1
        time.sleep(0.01)
        GPIO.output(self.E, GPIO.LOW)
        time.sleep(0.01)
        GPIO.output(self.E, GPIO.HIGH)

    def send_instruction(self, value):
        GPIO.output(self.RS, GPIO.LOW)
        self.set_data_bits(value)
        print('instruction: {0}'.format(value))

    def send_character(self, value):
        GPIO.output(self.RS, GPIO.HIGH)
        self.set_data_bits(value)

    def init_LCD(self):
        global cursorB
        global display
        self.send_instruction(56)
        self.send_instruction(15)
        cursorB = True
        display = True
        self.send_instruction(1)
        print('init check')

    def write_message(self, message, lijn):
        message = str(message)
        aantal = len(message)
        if aantal < 40:
            if lijn == "1":
                self.send_instruction(2)
                for i in range(0, aantal):
                    self.send_character(ord(message[i]))
            elif lijn == "2":
                self.send_instruction(168)
                for i in range(0, aantal):
                    self.send_character(ord(message[i]))
            else:
                print("verkeerde lijn!!!!!!!!")
        else:
            print("text te lang!!!!!!!!")

    def cursor_aanpassen(self):
        global cursorB
        if cursorB == True:
            self.send_instruction(14)
            cursorB = False
        elif cursorB == False:
            self.send_instruction(15)
            cursorB = True

    def scroll(self):
        self.send_instruction(24)
        time.sleep(0.01)

    def reverse_scroll(self):
        self.send_instruction(28)
        time.sleep(0.01)

    def display_on_off(self):
        global cursorB
        global display
        if display == True:
            self.send_instruction(8)
            display = False
        elif display == False:
            self.send_instruction(15)
            cursorB = True
            display = True

    def clear_display(self):
        self.send_instruction(1)
